import pyglet

from colors import *

class Button(object):
    def __init__(self, x, y, image, glow, text):
        self.x = x
        self.y = y
        self.text = pyglet.text.Label(text, font_name='ProggySquareTT', font_size=12, x=x+13, y=y+16, color=White.rgba())
        self.image = image
        self.glow = glow
        self.on = False

    def draw(self):
        if self.on:
            self.glow.blit(self.x, self.y)
        self.image.blit(self.x, self.y)
        self.text.draw()

blue = pyglet.resource.image('blue_button.png')
blueglow = pyglet.resource.image('blue_glow.png')
green = pyglet.resource.image('green_button.png')
greenglow = pyglet.resource.image('green_glow.png')
orange = pyglet.resource.image('orange_button.png')
orangeglow = pyglet.resource.image('orange_glow.png')

QButton = Button(430, 215, blue, blueglow, 'Q')
QButton.chord = [12, 25]
WButton = Button(478, 215, blue, blueglow, 'W')
WButton.chord = [1, 3, 5, 6, 9, 10, 11, 12, 15, 16, 17, 22, 23, 24, 25, 28, 29, 30, 35, 36]
EButton = Button(526, 215, blue, blueglow, 'E')
EButton.chord = [1, 3, 5, 7, 9, 10, 12, 15, 16, 18, 19, 22, 24, 25, 28, 29, 31, 32, 35]
RButton = Button(574, 215, blue, blueglow, 'R')
RButton.chord = [1, 3, 4, 6, 7, 9, 10, 11, 13, 14, 17, 19, 22, 23, 24, 26, 27, 30, 32, 35, 36]
TButton = Button(622, 215, blue, blueglow, 'T')
TButton.chord = [1, 2, 3, 4, 6, 7, 8, 10, 11, 12, 17, 18, 19, 20, 21, 23, 24, 25, 30, 31, 32, 33, 34, 36]

AButton = Button(446, 190, green, greenglow, 'A')
AButton.chord = [1, 2, 4, 6, 8, 9, 12, 13, 14, 17, 20, 21, 22, 25, 26, 27, 30, 33, 34, 35]
SButton = Button(494, 190, green, greenglow, 'S')
SButton.chord = [2, 3, 5, 6, 8, 10, 11, 12, 15, 16, 17, 20, 21, 23, 24, 25, 28, 29, 30, 33, 34, 36]
DButton = Button(542, 190, green, greenglow, 'D')
DButton.chord = [1, 3, 5, 7, 9, 10, 11, 12, 15, 16, 18, 19, 22, 23, 24, 25, 28, 29, 31, 32, 35, 36]
FButton = Button(590, 190, green, greenglow, 'F')
FButton.chord = [1, 3, 4, 6, 7, 9, 10, 11, 13, 14, 17, 18, 19, 22, 23, 24, 26, 27, 30, 31, 32, 35, 36]
GButton = Button(638, 190, green, greenglow, 'G')
GButton.chord = [1, 3, 4, 6, 7, 9, 10, 11, 12, 17, 18, 19, 22, 23, 24, 25, 30, 31, 32, 35, 36]

ZButton = Button(462, 165, orange, orangeglow, 'Z')
ZButton.chord = [1, 4, 6, 7, 9, 12, 13, 14, 17, 18, 19, 22, 25, 26, 27, 30, 31, 32, 35]
XButton = Button(510, 165, orange, orangeglow, 'X')
XButton.chord = [1, 2, 3, 4, 6, 8, 10, 11, 12, 13, 14, 17, 20, 21, 23, 24, 25, 26, 27, 30, 33, 34, 36]
CButton = Button(558, 165, orange, orangeglow, 'C')
CButton.chord = [1, 2, 3, 5, 7, 8, 10, 11, 12, 15, 16, 18, 19, 20, 21, 23, 24, 25, 28, 29, 31, 32, 33, 34, 36]
VButton = Button(606, 165, orange, orangeglow, 'V')
VButton.chord = [1, 3, 4, 5, 7, 8, 9, 10, 11, 13, 14, 15, 16, 18, 19, 22, 23, 24, 26, 27, 28, 29, 31, 32, 35, 36]
BButton = Button(654, 165, orange, orangeglow, 'B')
BButton.chord = [3, 10, 11, 23, 24, 36]

button_list = [
           QButton,
           AButton,
           ZButton,
           WButton,
           SButton,
           XButton,
           EButton,
           DButton,
           CButton,
           RButton,
           FButton,
           VButton,
           TButton,
           GButton,
           BButton]

Buttons = {pyglet.window.key.Q: QButton,
           pyglet.window.key.W: WButton,
           pyglet.window.key.E: EButton,
           pyglet.window.key.R: RButton,
           pyglet.window.key.T: TButton,

           pyglet.window.key.A: AButton,
           pyglet.window.key.S: SButton,
           pyglet.window.key.D: DButton,
           pyglet.window.key.F: FButton,
           pyglet.window.key.G: GButton,

           pyglet.window.key.Z: ZButton,
           pyglet.window.key.X: XButton,
           pyglet.window.key.C: CButton,
           pyglet.window.key.V: VButton,
           pyglet.window.key.B: BButton}
