class Color(object):
    def __init__(self, hex_string):
        self._hex_string = hex_string
        self._rgb = (int('0x' + hex_string[1 : 3], 0)
                    ,int('0x' + hex_string[3 : 5], 0)
                    ,int('0x' + hex_string[5 : 7], 0))
        self._normal = (self._rgb[0] / 255.
                       ,self._rgb[1] / 255.
                       ,self._rgb[2] / 255.)

    def hex(self):
        return self._hex_string

    def normal(self):
        return self._normal

    def normala(self, alpha=1.0):
        return (self._normal[0], self._normal[1], self._normal[2], alpha)

    def rgb(self):
        return self._rgb

    def rgba(self, alpha=255):
        return (self._rgb[0], self._rgb[1], self._rgb[2], alpha)

Black = Color('#222222')
Grey = Color('#646464')
White = Color('#949494')

Red = Color('#993333')
Green = Color('#667533')
Orange = Color('#996633')
Blue = Color('#336675')
Yellow = Color('#999944')
Purple = Color('#665066')

RoyGBiv = [Red, Orange, Yellow, Green, Blue, Purple]
