import pyglet

from colors import *

class MenuMode(object):
    def __init__(self, window):
        self.window = window
        self.title = pyglet.resource.image('title.png')
        self.menu_batch = pyglet.graphics.Batch()
        self.play = pyglet.text.Label('Play', font_size = 30, x=520, y=300, color=Blue.rgba(), batch=self.menu_batch)
        self.jam = pyglet.text.Label('Jam', font_size = 30, x=522, y=250, color=Green.rgba(), batch=self.menu_batch)
        self.edit = pyglet.text.Label('Edit', font_size = 30, x=520, y=200, color=Orange.rgba(), batch=self.menu_batch)
        self.exit = pyglet.text.Label('Take Five', font_size = 20, x=490, y=100, color=Grey.rgba(), batch=self.menu_batch)
        self.menu = [(self.play, self.on_play),
                     (self.jam, self.on_jam),
                     (self.edit, self.on_edit),
                     (self.exit, self.on_exit)]

    def on_play(self):
        self.window.select_mode()

    def on_jam(self):
        self.window.jam_mode()

    def on_edit(self):
        self.window.edit_mode()

    def on_exit(self):
        self.window.outro_mode()

    def on_key_press(self, symbol, modifiers):
        if symbol == pyglet.window.key.ESCAPE:
            self.window.outro_mode()

    def on_mouse_press(self, x, y, buttons, modifiers):
        for text, action in self.menu:
            if x >= text.x and x <=  text.x + text.content_width and\
                y >= text.y and y <= text.y + text.content_height:
                action()

    def update(self, dt):
        pass
                
    def draw(self):
        self.title.blit(0, 0)
        self.menu_batch.draw()
