import pyglet

class Plectrum(object):
    def __init__(self):
        self._husbands = []
        self._marriages = {}

    def marry(self, string, activate):
        '''
        When a pick marries a string they no longer communicate. Its ok,
        they'll be divorce in no time (.1 seconds) unless they stay together
        and keep fighting.
        '''
        if activate:
            string.activate()
        if string not in self._husbands:
            self._husbands.append(string)
        self._marriages[string] = .1

    def divorce(self, string):
        '''
        Before a pick and a string can communicate again they have to get
        divorced first. 
        '''
        string.deactivate()
        self._husbands.remove(string)
        self._marriages.pop(string)

    def update(self, dt):
        for husband in self._husbands:
            self._marriages[husband] -= dt
            if self._marriages[husband] <= 0:
                self.divorce(husband)
