import random
import pyglet

from colors import *

batch = pyglet.graphics.Batch()

gnote = pyglet.resource.image('green_note.png')
bnote = pyglet.resource.image('blue_note.png')
onote = pyglet.resource.image('orange_note.png')

class Note(pyglet.sprite.Sprite):
    def __init__(self, image, x, y, dy):
        super(Note, self).__init__(image, x, y, batch=batch)
        self.dy = dy
        self.opacity = 150

    def update(self, dt):
        self.y -= self.dy * dt

class Scroller(object):
    def __init__(self):
        self.notes = {}
        self.spawns = {1: (bnote, 442.5, 690),
                       2: (gnote, 458.5, 665),
                       3: (onote, 474.5, 640),
                       4: (bnote, 490.5, 690),
                       5: (gnote, 506.5, 665),
                       6: (onote, 522.5, 640),
                       7: (bnote, 538.5, 690),
                       8: (gnote, 554.5, 665),
                       9: (onote, 570.5, 640),
                      10: (bnote, 586.5, 690),
                      11: (gnote, 602.5, 665),
                      12: (onote, 618.5, 640),
                      13: (bnote, 634.5, 690),
                      14: (gnote, 650.5, 665),
                      15: (onote, 666.5, 640),
                 }

    def spawn(self, column, offset, velocity, beat):
        spawn = self.spawns[column]
        note = Note(spawn[0], spawn[1], spawn[2] + offset, velocity)
        self.notes[beat] = note

    def flash(self):
        for note in self.notes.itervalues():
            if note:
                note.opacity = 255

    def unflash(self):
        for note in self.notes.itervalues():
            if note:
                note.opacity = 150

    def update(self, dt):
        for note in self.notes.itervalues():
            if note:
                note.update(dt)

    def draw(self):
        batch.draw()
